#include "i18n.h"
#include <string.h>
#include <stdlib.h>
#include <dirent.h>
#include <limits.h>

int strcntchar(const char * s, char c)
{
	for (int i = 0; ; ++s, ++i)
	{
		if (!(s = strchr(s, c)))
			return i;
	}
}

char * sgettext (const char *msgid)
{
	char *msgval = gettext(msgid);
	int pipeCount = strcntchar(msgid, '|');
	if (pipeCount && pipeCount == strcntchar(msgval, '|'))
		msgval = strchr(msgval, '|') + 1;
	return msgval;
}

const char * get_gettext_language()
{
	char * c;
	if (c = getenv("LANGUAGE"))
		return c;
	if (c = getenv("LC_ALL"))
		return c;
	if (c = getenv("LC_MESSAGES"))
		return c;
	return getenv("LC_LANG");
}

char get_help_dir_result[NAME_MAX+1];

const char * get_help_dir()
{
	char lang[NAME_MAX+1];
	const char * helpdir = HELPDIR;
	const char * l = get_gettext_language();
	if (!l)
		return helpdir;
	strcpy(lang, l);
	DIR * dir = NULL;
	for (int i = 0; i < 3; ++i)
	{
		strcpy(get_help_dir_result, helpdir);
		strcat(get_help_dir_result, "/");
		strcat(get_help_dir_result, lang);
		dir = opendir(get_help_dir_result);
		if (dir)
		{
			struct dirent * dirEntry;
			while ((dirEntry = readdir(dir)) != NULL)
			{
				if (!strcmp(dirEntry->d_name, ".") || !strcmp(dirEntry->d_name, ".."))
					continue;
				closedir(dir);
				return get_help_dir_result;
			}
		}
		char * c = strchr(lang, '.');
		if (c)
			*c = 0;
		else
		{
			c = strchr(lang, '_');
			if (c)
				*c = 0;
			else
				break;
		}
	}
	if (dir)
		closedir(dir);
	return helpdir;
}
